# NOTE: Derived from blib/lib/Class/MethodMaker.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Class::MethodMaker;

#line 3020 "blib/lib/Class/MethodMaker.pm (autosplit into blib/lib/auto/Class/MethodMaker/deep_copy.al)"
# ----------------------------------------------------------------------


sub deep_copy {
  my ($class, @args) = @_;
  my %methods;

  eval 'use Storable;';
  eval 'use Data::Dumper;' if $@;

  foreach (@args) {
    my $name = $_;

    $methods{$name} = sub {
      my $self = shift; my $class = ref $self;

      if ( Storable->VERSION ) {
        return Storable::dclone $self;
      } else {
        my $copy;
        eval Data::Dumper->Dump([$self],['copy']);
        return $copy;
      }
    };
  }

  $class->install_methods(%methods);
}

# end of Class::MethodMaker::deep_copy
1;
